/*  This program gives students the opportunity to check math computation 
that may have been assigned as written work.  It is designed for classroom 
support in grades 1-3.  Students enter the problem with their answers; the 
machine reports the answers as correct or incorrect, and suggests possible 
errors for addition, subtraction, and division.  It does not ever disclose 
the correct answer.  The student must find that for himself.


                       /*  CHECK IT OUT vers 9/29/05
                      Copyright (C) 2005 by John Slayton

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY;  without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General  Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Boston, MA 02110-1301, USA.

Author's current address is 260 Sundance Court, Azusa, CA, 91702. 9/17/05 
  */

#ifdef HAVE_LIBCURSES
#include <curses.h>
#else
#include <ncurses/curses.h>
#endif
#include <time.h>
#include <stdio.h>
#include <stdlib.h>

                           /*  Variables  */

int a = 0; /*  opening loop counter, also holds ASCII from getch()  */
int e = 0;
int c = 1; /*  c is endless loop counter  */ 
int d = 0; 
int f = 0; /*  f counts internal loop  */
int r = 0; /*  counter used to reverse digit order  */
int operation = 0; /*  Will hold ASCII code for math operator  */
int panic = 0; /*  flag to escape from subroutines  */
int remainder = 0; /*  holds remainder of right answer  */
int leftover = 0; /*  holds remainder of student answer  */
 
int ex1[7]; /*  1st term digits stored as binary  */
int dupex1[7]; /*  temporary cpy of ex1  */
int ex2[7]; /*  2nd term digits stored as binary  */
int ex3[7]; /*  student answer digits stored as binary  */
int ex4[7]; /*  correct answer digits stored as binary  */
int term1[7]; /*  7 digits stored as ASCII  */
int term2[7]; /*  7 digits stored as ASCII */
int answer[7]; /*  7 digits stored as ASCII */

long int b=0; /*  b is opening stall counter  */ 
long int term1_binary = 0; /*  7 digit number stored as binary  */
long int term2_binary = 0; /*  7 digit number stored as binary  */
long int term3_binary = 0; /*  7 digit number stored as binary  */
long int term4_binary = 0; /*  7 digit number stored as binary  */

long int dummy[7];

                         /*  Functions  */

int analyze_add();
int analyze_sub();
int analyze_mul();
int analyze_div();

int main()
{
                      /*  Set ncurses parameters  */

  initscr();
  cbreak();
  noecho();
  nonl();
  intrflush (stdscr, FALSE);
  keypad (stdscr, TRUE);

                       /*  Set letter attributes  */ 
 
  wattron (stdscr, A_BOLD);
  start_color();
  init_pair (1, COLOR_RED, COLOR_WHITE);
  init_pair (2, COLOR_BLUE, COLOR_WHITE);
  init_pair (3, COLOR_GREEN, COLOR_WHITE);
  init_pair (4, COLOR_MAGENTA, COLOR_WHITE);
  init_pair (5, COLOR_BLACK, COLOR_WHITE);
  bkgd (COLOR_PAIR (1)); 

                       /*  Present Introduction  */

  clear();
  attron (COLOR_PAIR(1));
  
  mvprintw (2, 25, "        CHECK IT OUT\n");
  printw ("                                Version 9/29/05");
 
                         /*  Add Copyright Notice  */

  for (a = 25; a > 8; a--) 
    {
      mvprintw (a, 15, "                 By John Slayton\n"
      "                                Copyright  2005\n\n\n\n"
      "                               Distributable under\n"
      "                            Gnu General Public License\n"
      "                             Free Software Foundation\n"
      "                       51 Franklin St, Boston, MA 02110-1301\n"
      "                                                                 "
      "                         ");                     
      refresh();
      for (b = 0; b < 10000000; b++);
    }
  attron (COLOR_PAIR(5));
  mvprintw (23, 3, "Push Enter to start..."); 
  refresh();
  getch();
  attron (COLOR_PAIR(1));

                       /*  Enter Menu and Program  */

  while (c == 1)
    {
      start:
      clear();
      mvprintw (3, 30, "   JUST CHECKING\n\n\n");      
      attron (COLOR_PAIR(2));
      printw ("   What seems to be the problem?   ");
      refresh();
      attron (COLOR_PAIR(1));
      term1_binary = 0;
      term2_binary = 0;
      term4_binary = 0;
      remainder = 0;

                            /*  Get First Term  */

      term1_binary = 0;
      for (d = 0; d < 8; d++)
        {
          ex1[d] = 0;
          dummy[d] = 0;
          term1[d] = 0;
        }
      d = 1; 
      while (d < 8)
        {
          getnumber1:
          panic = 0;
          a = 0;
          while ((a < 48) || (a > 57))
            {
              a = getch();
              if (a == '\033')
                {
                  goto start;
                }
              if ((a == 42) || (a == 43) || (a == 45) || (a == 47))
                {
                  d--;
                  goto summary1;
                }
              if (a == 13)
                {
                  if (d == 1)
                    {
                      goto start;
                    }
                  d--;
                  goto summary1;
                }
            }
          printw ("%c",a);
          refresh();   
          term1[d] = a;
          dummy[d] = a - 48;
          term1_binary = (10 * term1_binary + (a - 48)); /* Convert char 
to int  */
          if (d == 7)
            {
              break;
            }
          d++; 
        }
      summary1: /*  Reverses digit order; ones are in subscript 1.  */
      r = 1;
      for (d = d; d > 0; d--)
        {
          ex1[r] = dummy[d];
          r++;
        }           
       
                           /*  Get Operator  */

      if ((a == 42) || (a == 43) || (a == 45) || (a == 47))
        {
          goto printoperator;
        }   
      while (1 == 1)
        {
          a = getch();
          if ((a == 42) || (a == 43) || (a == 45) || (a == 47))
            {
             break;
            }
        }
      printoperator:
      operation = a; /*  Save operator.  */
      printw ("  %c  ",a);
      refresh();
        
                            /*  Get Second Term  */

      term2_binary = 0;
      for (d = 1; d < 8; d++)
        {
          a = 0; 
          ex2[d] = 0; 
          dummy[d] = 0;
        }
      d = 1;
      while (d < 8)
        {
          getnumber2:
          panic = 0;
          a = 0;
          while ((a < 48) || (a > 57))
            {
              a = getch();
              if (a == '\033')
                {
                  goto start;
                }
              if (a == 13)
                {
                  if (operation == 47 && term2_binary == 0)
                    {
                      clear();
                      mvprintw (12, 27, "YOU CAN'T DIVIDE BY 0, DUMMY.");
                      mvprintw (23, 3, "Press Enter to continue...");
                      refresh();
                      getch();
                      goto start; 
                    }
                  d--;
                  goto summary2;
                }
            }
          printw ("%c", a);
          refresh();
          dummy[d] = a - 48;
          term2_binary = (10 * term2_binary + (a - 48)); /*  Change char 
                                                            to binary  */
          if (d == 7)
            {
              a = 0;
              while (a != 13)
                {
                  a = getch();
                }    
              break;
            }
          d++;
        }

      summary2: /*  Reverse digit order; ones are in subscript 1.  */
      r = 1;
      for (d = d; d > 0; d--)
        {
          ex2[r] = dummy[d];
          r++;
        }           

                           /*  Get Student Answer  */

      retry:
      attron (COLOR_PAIR(2));
      mvprintw (8, 3, "What answer did you get?                      ");    
      mvprintw (13, 3,"                                                 "
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                                                 " 
                    "                        ");
      mvprintw (8, 33,"");
      refresh();
      attron (COLOR_PAIR(1));
      term3_binary = 0;
      remainder = 0;
      leftover = 0;
      for (d = 1; d < 8; d++)
        {
          a = 0; 
          ex3[d] = 0; 
          dummy[d] = 0;
        }
       d = 1;
       while (d < 8)
         {
           panic = 0;
           a = 0;
           while ((a < 48) || (a > 57))
             {
               a = getch();
               if (a == '\033')
                 {
                   goto start;   
                 }
               if((a == 82) || (a == 114)) /*  Look for R or r  */
                 {
                   printw (" %c ",a);
                   refresh();
                   while ((a < 48) || (a > 57))
                     {
                       e = getch();
                       if (e == '\033')
                         {
                           goto start;
                         }
                       if (e == 13)
                         {
                           goto summary3;
                         }
                       printw ("%c",e);
                       leftover = 10 * leftover + (e - 48);
                     }                     
                 }   
               if (a == 13)
                 {
                   d--;
                   goto summary3;
                 }
             }
           printw ("%c", a);
           refresh();
           dummy[d] = a - 48;
           term3_binary = (10 * term3_binary + (a - 48));
           if (d == 7)
             {
               while (a != 13)
                 {
                   a = getch();
                 }
               break;
             }
           d++;
         } 
      summary3: /*  Reverse digit order; ones are in subscript 1.  */
      r = 1;
      for (d = d; d > 0; d--)
        {
          ex3[r] = dummy[d];
          r++;
        }           
                       /*  Calculate Correct Answer  */
      remainder = 0;
      term4_binary = 0;
      for (d = 0; d < 8; d++)
        {
          ex4[d] = 0;
        }
      if (operation == 43) /*  This is addition  */
        {
          ex4[1] = ex1[1] + ex2[1];
          if (ex4[1] > 9)
            {
              ex4[2]++;
              ex4[1] = ex4[1] - 10;
            }
          ex4[2] = ex4[2] + ex1[2] + ex2[2]; /*  Carry to tens  */
          if (ex4[2] > 9)
            {
              ex4[3]++;
              ex4[2] = ex4[2] - 10;
            }
          ex4[3] = ex4[3] + ex1[3] + ex2[3]; /*  Carry to hundreds  */
          if(ex4[3] > 9)
            {
              ex4[4]++;
              ex4[3] = ex4[3] - 10;
            }
          ex4[4] = ex4[4] + ex1[4] + ex2[4]; /*  Carry to thousands  */
          if(ex4[4] > 9)
            {
              ex4[5]++;
              ex4[4] = ex4[4] - 10;
            }
          ex4[5] = ex4[5] + ex1[5] + ex2[5]; /*  Carry to ten thousands  */
          if(ex4[5] > 9)
            {
              ex4[6]++;
              ex4[5] = ex4[5] - 10;
            }
          ex4[6] = ex4[6] + ex1[6] + ex2[6]; /* Carry to hundred thousands  */ 
          if (ex4[6] > 9)
            {
              ex4[7]++;
              ex4[6] = ex4[6] - 10;
            }  
          term4_binary = term1_binary  +  term2_binary;
        }
      if (operation == 45) /*  This is subtraction  */
        { 
          for (d = 0; d < 8; d++)
            {
              dupex1[d] = ex1[d];
            }
          if (ex2[1] > dupex1[1])
            { 
              dupex1[1] = dupex1[1] + 10;
              dupex1[2]--;
            }
          ex4[1] = dupex1[1] - ex2[1];
          if (ex2[2] > dupex1[2])
            { 
              dupex1[2] = dupex1[2] + 10;
              dupex1[3]--;
            }
          ex4[2] = dupex1[2] - ex2[2];
          if (ex2[3] > dupex1[3])
            { 
              dupex1[3] = ex1[3] + 10;
              dupex1[4]--;
            }
          ex4[3] = dupex1[3] - ex2[3];
          if (ex2[4] > dupex1[4])
            { 
              dupex1[4] = dupex1[4] + 10;
              dupex1[5]--;
            }
          ex4[4] = dupex1[4] - ex2[4];
          if (ex2[5] > dupex1[5])
            { 
              dupex1[5] = dupex1[5] + 10;
              dupex1[6]--;
            }
          ex4[5] = dupex1[5] - ex2[5]; 
          if (ex2[6] > dupex1[6])
            { 
              dupex1[6] = dupex1[6] + 10;
              dupex1[7]--;
            }
          ex4[6] = dupex1[6] - ex2[6];
          term4_binary = term1_binary - term2_binary;
        } 
      if (operation == 42) /*  This is multiplication  */
        {
          ex4[1] = ex1[1] * ex2[1];
          ex4[2] = ex1[2] * ex2[2];
          ex4[3] = ex1[3] * ex2[3];
          ex4[4] = ex1[4] * ex2[4];
          ex4[5] = ex1[5] * ex2[5];
          ex4[6] = ex1[6] * ex2[6];
          term4_binary = term1_binary * term2_binary;
        }
      if (operation == 47) /*  This is division  */
        {
          term4_binary = term1_binary / term2_binary;
          remainder = term1_binary % term2_binary;
        }

                    /*  Evaluate Student Answer  */

      if ((term3_binary == term4_binary) && (remainder == leftover)) 
        {
          clear();
          attron (COLOR_PAIR(4));
          mvprintw (14, 35, "GOOD WORK!");
          refresh();
          attron (COLOR_PAIR(1));
          getch();
          goto start;
        }
      else
        {
          attron (COLOR_PAIR(4));
          mvprintw (12, 34, "YOU GOOFED!");
          refresh();
          attron (COLOR_PAIR(1));
          if (operation == 43)
            {
              analyze_add();
            }
          if (operation == 45)
            {
              analyze_sub();
            }
          if (operation == 42)
            {
              analyze_mul();
            }
          if (operation == 47)
            {
              analyze_div();
            }
          mvprintw (12,34,"                      ");
          if (a == 27)
            {
              goto start;
            }
          goto retry;
      }
    }
  return 0;
}

int analyze_add()
{
  mvprintw (13,3,"");
  if ((ex1[1] + ex2[1] > 9) && (ex4[2] - ex3[2] == 1)) 
    {
      printw ("\n\n   Did you forget to carry to tens?");
    }
  if ((ex1[2] + ex2[2] > 9) && (ex4[3] - ex3[3] == 1))
    {
      printw ("\n\n   Did you forget to carry to hundreds?");
    }
  if ((ex1[3] + ex2[3] > 9) && (ex4[4] - ex3[4] == 1))
    {
      printw ("\n\n   Did you forget to carry to thousands?");
    }
  if ((ex1[4] + ex2[4] > 9) && (ex4[5] - ex3[5] == 1))
    {
      printw ("\n\n   Should you carry to ten thousands?");
    }
  if ((ex1[5] + ex2[5] > 9) && (ex4[6] - ex3[6] == 1))
    {
      printw ("\n\n   Should you carry to hundred thousands?");
    }
  refresh();
  a=getch();
  return 0;
}

int analyze_div()
{
  mvprintw (13,3,"");
  if (leftover > term2_binary)
    {
      printw ("\n\nYou can't have that much left over!");
      printw ("\nThat's more than the divisor!");
    }
  if ((leftover == 0) && (remainder > 0))
    {
      printw ("\n\nDon't you have something left over?");
    }
  getch();
  return 0;
}

int analyze_mul()
{
  getch();
  return 0;
}

int analyze_sub()
{
                /*  Subtracted Top Number from Bottom?  */

  mvprintw (13, 3, "");
  if ((ex1[1] - ex2[1] < 0) && (ex3[1] == ex2[1] - ex1[1]))
    {
      printw ("\n\n   Did you subtract the top number from "
                     "the bottom in the ones?");
    }
  if ((ex1[2] - ex2[2] < 0) && (ex3[2] == ex2[2] - ex1[2]))
    {
      printw ("\n\n   Did you subtract the top number from "
                    "the bottom in the tens?");
    }
  if ((ex1[3] - ex2[3] < 0) && (ex3[3] == ex2[3] - ex1[3]))
    {
      printw ("\n\n   Did you subtract the top number from "
                    "the bottom in the hundreds?");
    }
  if ((ex1[4] - ex2[4] < 0) && (ex3[4] == ex2[4] - ex1[4]))
    {
      printw ("\n\n   Did you subtract the top number from "
                    "the bottom in the thousands?");
    }
  if ((ex1[5] - ex2[5] < 0) && (ex3[5] == ex2[5] - ex1[5]))
    {
      printw ("\n\n   Did you subtract the top number from "
                    "the bottom in the ten thousands?");
    }

                /*  Borrowed and Forgot to Debit Lender?  */

  if ((ex1[1] < ex2[1]) && (ex3[2] - ex4[2] == 1))
    {
      printw ("\n\n   Did you borrow from the tens?\n"
             "   Did you take one away from the lender?");
    } 
  if ((ex1[2] < ex2[2]) && (ex3[3] - ex4[3] == 1))
    {
      printw ("\n\n   Did you borrow from the hundreds?\n"
             "   Did you take one away from the lender?");
    } 
  if ((ex1[3] < ex2[3]) && (ex3[4] - ex4[4] == 1))
    {
      printw ("\n\n   Did you borrow from the thousands?\n"
                 "   Did you take one away from the lender?");
    }
  if ((ex1[4] < ex2[4]) && (ex3[5] - ex4[5] == 1))
    {
      printw ("\n\n   Did you borrow from the ten thousands?\n"
                  "   Did you take one away from the lender?");
    }
  if ((ex1[5] < ex2[5]) && (ex3[6] - ex4[6] == 1))
    {
      printw ("\n\n   Did you borrow from the hundred thousands?\n"
                 "   Did you take one away from the lender?");
    }
  if ((ex1[6] < ex2[6]) && (ex3[7] - ex4[7] == 1))
    {
      printw ("\n\n   Did you borrow from the millions?\n"
                "   Did you take one away from the lender?");
    }
   
  refresh();
  a = getch();
  return 0;
 }
