/*  This program gives students practice in comparing magnitude of two, 
three, and four digit numbers.  Alternatively, one may order two, three, 
or four digit numbers from smallest to largest.  Although nominally in 
game format, it is really intended to provide minor support for grade 1-3 
classrooms.  This and several similar programs may run continuously on 
different virtual consoles.

                     MORE OR LESS NCURSES ver. 9/28/05
                    Copyright (C) 2005 by John Slayton

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Boston, MA, 02110-1301, USA.

Author's current address is 260 Sundance Ct, Azusa, CA 91792. 9/17/05 */

#ifdef HAVE_LIBCURSES
#include <curses.h>
#else
#include <ncurses/curses.h>
#endif

#include <stdio.h>
#include <stdlib.h>

                             /*  VARIABLES  */

int a = 0;
int b = 0;
int c = 0; 
int d = 0;
int e = 0;
int f = 0;
int o = 0; /*  Game flag.  On 0 branch to comparison, on 1 to ordering  */
int n = 0;
int n1 = 0;
int n2 = 0;
int n3 = 0;
int n4 = 0;
int nr = 0;
int panic = 0;
int score = 0;
int seed = 0;
int sp = 0;
int t1 = 0;
int t2 = 0;
int t3 = 0;
int t4 = 0;
int win = 0;

int color[25] = {1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1 };

                             /*  METHODS  */

int bad(); /*  Reports wrong answers and zero score to screen  */
int chance(); /*  Generates pseudorandom numbers  */
int compare_numbers(); /*  Manages comparison exercises  */
int check_order(); /*  Evaluates student answers for ordering game  */
int check_compare(); /*  Evaluates student answers for comparison game  */
int get_answer();
int good(); /*  Reports right answers and new score  */
int input_character(); /* Handles student input of numbers  */
int input_operator(); /*  Handles student input of ">", "=", and "<"  */
int order_numbers(); /*  Manages ordering exercises  */
int WIN();

                        /*  START OF PROGRAM  */

int main()
{
                 /*  Initialize random number generation  */

  seed = time(NULL); 
  srand(seed);

                        /*  Set ncurses parameters  */  

  initscr();
  cbreak();
  noecho();
  nonl();
  intrflush (stdscr,FALSE);
  keypad (stdscr,TRUE);
  curs_set(0);

                           /*  Set letter attributes  */

  start_color();
  init_pair (1, COLOR_RED, COLOR_WHITE);
  init_pair (2, COLOR_BLUE, COLOR_WHITE);
  init_pair (3, COLOR_GREEN, COLOR_WHITE);
  init_pair (4, COLOR_MAGENTA, COLOR_WHITE);
  init_pair (5, COLOR_CYAN, COLOR_BLACK);
  init_pair (6, COLOR_GREEN, COLOR_BLACK);
  init_pair (7, COLOR_BLACK, COLOR_WHITE);
  bkgd (COLOR_PAIR(1));

                            /*   Print title page  */

  attron (COLOR_PAIR(1));
  leap:
  clear();
  mvprintw (5,34," MORE OR LESS\n"
  "                                  Version 9/28/05\n\n\n\n");
  attron (COLOR_PAIR(4));
  printw("                                  by John Slayton\n"
         "                                  Copyright  2005\n\n\n\n");
  attron (COLOR_PAIR(2));
  printw ("                            Distributable under the GNU\n"
  "                              General Public License\n\n"
  "                        Contact the Free Software Foundation\n"
  "                       51 Franklin St, Boston, MA 02110-1301");
  attron (COLOR_PAIR(1));
  mvprintw (23, 3, "Push Enter to start...");
  refresh();
  attron (COLOR_PAIR(2));
  getch();

                            /*  Print Menu  */

  while (1 == 1)
    {
      clear();
      mvprintw (5, 15, "            BIG BIGGER BIGGEST\n\n");
      attron (COLOR_PAIR(1));
      printw ("                         Two Numbers to Compare\n\n"
      "                         A - With Two Digits\n"
      "                         B - With Three Digits\n"
      "                         C - With Four Digits\n\n\n");
      attron (COLOR_PAIR(4));
      printw ("                         Four Numbers to Order\n\n"
      "                         D - With Two Digits\n"
      "                         E - With Three Digits\n"
      "                         F - With Four Digits\n\n");
      attron (COLOR_PAIR(7));
      printw ("                         G - Exit the Program");
      refresh();

                        /*  Select from menu  */
  
      a = 0;
      while ((a < 65 || a > 71) && (a < 97 ||  a > 103) ) /* report 'a-g'  */
        {
          a = getch();
          d = 0; 
          if (a > 90) /*  Change ASCII lower case to upper  */
            {
              a = a - 32;
            }
          if (a == 65) /*  Select 2 digit comparisons  */
            {
              o = 0;
              f = 100;
              sp = 1;
            }
          if (a == 66) /*  Select 3 digit comparisons  */
            {
              o = 0;
              f = 1000;
              sp = 2; 
            }
          if (a == 67) /*  Select 4 digit comparisons  */
            {
              o = 0;
              f = 10000;
              sp = 3;
            }
          if (a == 68) /*  Select 2 digit ordering problems  */
            {
              o = 1;
              d = 2;
              f = 100;
            }
          if (a == 69) /*  Select 3 digit ordering problems  */
            {
              o = 1;
              d = 3;
              f = 1000;
            }
          if (a == 70) /*  Select 4 digit ordering problems  */
            {
              o = 1;
              d = 4;
              f = 10000;
            }
          if (a == 71) /*  Select program exit  */
            {
              nocbreak();
              endwin();
              return 0;
            }
        }

             /*  Branch to comparison or ordering methods  */

      if (o == 0)
        {
          compare_numbers();
        }
      else
        {
          order_numbers();
        }
      if (panic == 1)
        {
          score = 0;
          curs_set(0);
        }
      panic = 0;
    }
}

           /*  FUNCTION DEFINITIONS (in alphabetical order)  */

int bad()  /*  Report bad answers; Reset score to 0  */
{
  curs_set(0);
  bkgd (COLOR_PAIR(6));
  score=0;
  attron (COLOR_PAIR(5));
  attron (A_BLINK);
  attron (A_BOLD);
  mvprintw (14, 13, "YOU GOOFED!\n\n\n\n");
  printw ("                            SCORE IS %d \n\n\n\n", score);
  attroff (A_BLINK); 
  attroff (A_BOLD);
  attron (COLOR_PAIR(6));
  mvprintw (22, 43, "Push ENTER for Next Problem");
  refresh();
  a=getch();
  if (a == '\033')
    {
      panic = 1;
    }
  bkgd (COLOR_PAIR(1));
  return 0;
}


int chance() /*  generate random number within selected range  */
{
  back:
  while(1==1)
    {
      b=random() / (2000000000 / f);
      if ( (b <= (f - 1)) && (b >= (f / 10)) && (b != 0) )  
        {
          return 0;
        }
    }
}

int check_compare() /*  Evaluate student answers in comparison  */
{
  if (d == 1)
    {
      if (panic == 1)
        {
          return 0;
        }
      if (n1 < n2)
        {
          good();
        }
      else 
        {
          bad();
        }
    }
  if(d == 2)
    {
      if (panic == 1)
        {
          return 0;
        } 
      if (n1 > n2)
        {
          good();
        }
      else
        {
          bad();
        }
    }
  if(d == 3)
    { 
      if (panic == 1)
        {
          return 0;
        }
      if (n1 == n2)
        {
          good();
        }
      else
        {
          bad();
        }
    }
  return 0;
} 

int check_order() /*  Evaluate student answers in ordering section  */
{

  /*  Check to see if answers are ordered by size  */

  if ( ! (n1 <= n2) && (n2 <= n3) && (n3 <= n4) ) 
    {
      bad();
      return 0;
    }

  /*  Check to see if student actually used the problem numbers  */

  if ( ( (n1 == t1) || (n1 == t2) || (n1 == t3) || (n1 == t4))
          && ((n2 == t1) || (n2 == t2) || (n2 == t3) || (n2 == t4))
          && ((n3 == t1) || (n3 == t2) || (n3 == t3) || (n3 == t4))
          && ((n4 == t1) || (n4 == t2) || (n4 == t3) || (n4 == t4) ) )
    {
      good();
    }
  else
    {
      bad();
    }
  return 0;
}

int compare_numbers()
{
  cycle:
  curs_set(1);
  clear();
  attron (COLOR_PAIR(7));
  mvprintw (5, 15, "COMPARE THESE NUMBERS USING THE SYMBOLS >, <, OR =");
  attron (COLOR_PAIR(1));
  chance();
  n1 = b;
  mvprintw (15, 30, "%d", n1);
  chance();
  n2 = b;
  mvprintw (15, 40, "%d", n2);
  refresh();
  input_operator();
  refresh(); /*  Display answer  */
  if (panic == 1)
    {
      return 0;
    } 
  check_compare();
  if (panic == 1)
    {
      return 0;
    }
  goto cycle;
  return 0;
} 

int get_answer()
{
  n1 = 0;
  n2 = 0;
  n3 = 0;
  n4 = 0;
  mvprintw (11, 23, "");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n1 = (10 * n1) + n;
      if (panic == 1)
        {
          return 0;
        }
    }
  mvprintw (11, 33, "");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n2 = (10 * n2) + n; 
      if (panic == 1)
        {
          return 0;
        }
    }
  mvprintw (11,43,"");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n3 = (10 * n3) + n;
      if (panic == 1)
        {
          return 0;
        }
    }
  mvprintw (11, 53, "");
  for (nr = d; nr > 0; nr--)
    {
      input_character();
      refresh();
      n4 = (10 * n4) + n;
      if (panic == 1)
        {
          return 0;
        }
    }
  return 0;
} 

int good()
{
  curs_set(0);
  if (score == 4)
    {
      WIN();
      return 0;
    }
  score = score + 1;
  attron (COLOR_PAIR(7));
  mvprintw (14, 13, "GOOD WORK!\n\n\n\n");
  attron (COLOR_PAIR(1));
  printw ("                            SCORE IS %d", score);
  attron (COLOR_PAIR(7));
  mvprintw (22, 43, "Push ENTER for Next Problem");
  refresh();
  attron (COLOR_PAIR(1));
  a = getch();
  if (a == '\033')
    {
      panic = 1;
    }
  return 0;
}

int input_character()
{ 
  a = 0;
  while (1 == 1)
    {
      a = getch();
      if (a == '\033')
        {
          panic = 1;
          return 0;
        }
      if (a > 47 && a < 58)
        {
          n = a - 48;
          printw ("%c", a);
          return 0;
        }
    }
  return 0;
}

int input_operator()
{ 
  attron (COLOR_PAIR(2));
  pickuno:
  a = mvgetch (15, 35);
  d = 0; 
  if (a == '\033')
    {
      panic = 1;
      return 0;
    }
  if (a == ',')
    {
      d = 1;
      mvprintw (15, 35, "<");
      return 0;
    }
  if (a == '.')
    {
      d = 2;
      mvprintw (15, 35, ">");
      return 0;
    }
  if (a == '=')
    {
      d = 3;
      mvprintw (15, 35, "=");
      return 0;
    }
  goto pickuno;
  return 0;
}
 
int order_numbers()
{
  Cycle:
  curs_set(1);
  clear();
  attron (COLOR_PAIR(7));
  mvprintw (4, 25, "PUT THESE NUMBERS IN ORDER.");
  mvprintw (6, 27, "START WITH THE SMALLEST.");
  attron (COLOR_PAIR(4));
  chance();
  t1 = b; 
  mvprintw (9, 23, "%d", t1);
  chance();
  t2 = b; 
  mvprintw (9, 33, "%d", t2);
  chance();
  t3 = b; 
  mvprintw (9, 43, "%d", t3);
  chance();
  t4 = b; 
  mvprintw (9, 53, "%d", t4);
  refresh();
  attron (COLOR_PAIR(1));
  get_answer();
  if (panic == 1)
    {
      return 0;
    }
  check_order();
  if (win == 1)
    {
      WIN();
      return 0;
    } 
  if (panic == 1)
    {
      return 0;
    }
  goto Cycle;
  return 0;
}

int WIN()
{
  curs_set(0);
  clear();
  for(e = 0; e < 25; e++)
    {
      attron (COLOR_PAIR(color[e]));
      mvprintw (e, e*3, "YOU WIN!  ");
      refresh();
      for (a = 0; a < 8000000; a++) ;
    }
  a=getch();
  if (a == '\033'|a == 13)
    {
      panic = 1;
    }
  score = 0; 
  win = 0;
  return 0;
}
