/*  This program presents the user with spelled-out numbers and asks him 
to re-enter them in standard mathematical notation.  Difficulty levels 
range from one to four digits.  The program is designed to provide support 
to classrooms in grades 1-3.


              /*  NUMBER PLEASE CURSES version 9/29/05
                   Copyright (C) 2005 by John Slayton
 
This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This progrdam is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Boston, MA 02110-1301, USA.

Author's address as of 9/17/05 is 260 Sundance Ct, Azusa, CA 91792. */

#include <stdio.h>
#include <stdlib.h>
#ifdef HAVE_LIBCCURSES
#include <curses.h>
#else
#include<ncurses/curses.h>
#endif

                          /*  Variables  */ 

long int c = 0; /*  used in WIN() to stop and count  */
int a = 0; /*  holds input from getch(), also loop counter in WIN()  */
int a1 = 0; /*  holds ones digit of student answer  */
int a2 = 0; /*  holds tens digit of student answer  */
int a3 = 0; /*  holds hundreds digit of student answer  */
int a4 = 0; /*  holds thousands digit of student answer  */
int b = 0; /*  a random number generated by rand  */
int d = 0; /*  holds number of digits in current problem  */
int nr = 0; /*  holds current place value being inpu t */
int n1 = 0; /*  holds ones digit of right answer  */
int n2 = 0; /*  holds tens digit of right answer  */
int n3 = 0; /*  holds hundreds digit of right answer  */
int n4 = 0; /*  holds thousands digit of right answer  */
int panic = 0; /*  used to pass through all subroutines on 'escape'  */
int quitflag = 0;
int r = 0 ; /*  a number from hardware clock, used to seed srand  */
int score = 0;
int win = 0;

                   /*  color pairs used by 'win' display  */

int color[25] = {1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5,1,2,3,4,5};
      

char C[80] = "";
char L[80] = "";

                            /*  spelling list  */
char h[2] = "-";
char N0[5] = "zero";
char N1[4] = "one";
char N2[4] = "two";
char N3[6] = "three";
char N4[5] = "four";
char N5[5] = "five";
char N6[4] = "six";
char N7[6] = "seven";
char N8[6] = "eight";
char N9[5] = "nine";
char N10[4] = "ten";
char N11[7] = "eleven";
char N12[7] = "twelve";
char N13[9] = "thirteen";
char N14[9] = "fourteen";
char N15[8] = "fifteen";
char N16[8] = "sixteen";
char N17[10] = "seventeen";
char N18[9] = "eighteen";
char N19[9] = "nineteen";
char N20[7] = "twenty";
char N30[7] = "thirty";
char N40[6] = "forty";
char N50[6] = "fifty";
char N60[6] = "sixty";
char N70[8] = "seventy";
char N80[7] = "eighty";
char N90[7] = "ninety";
char N100[10] = " hundred ";
char N1000[11] = " thousand ";

char T[80] = "";
char Z[80] = ""; /*  empty string to copy and clear other registers  */

                          /*  Functions  */

int bad(); /*  displays error message and zero score  */
int chance(); /*  returns pseudorandom numbe r  */
int check_answer(); /*  compares student answer with right answer  */
int create(); /*  generates written number  */
int digit1(); /*  selects and spells out ones digit  */
int digit2(); /*  selects and spells out tens digit  */
int digit3(); /*  selects and spells out hundreds digit  */
int digit4(); /*  selects and spells out thousands digit  */
int get_answer(); /* inputs student response  */
int good(); /*  displays score and acknowledges right answer  */
int WIN();  /*  acknowledges win score (5 right)  */

int main()
{   

                   /*  SET CURSES PARAMETERS  */

  initscr();
  cbreak();
  noecho();
  nonl();
  intrflush (stdscr, FALSE);
  keypad (stdscr, TRUE);
    
                   /*  SET LETTER ATTRIBUTES  */

  start_color();
  init_pair (1, COLOR_BLACK, COLOR_WHITE);
  init_pair (2, COLOR_RED, COLOR_WHITE);
  init_pair (3, COLOR_GREEN, COLOR_WHITE);
  init_pair (4, COLOR_MAGENTA, COLOR_WHITE);
  init_pair (5, COLOR_BLUE, COLOR_WHITE);
  init_pair (6, COLOR_RED, COLOR_BLACK);
  init_pair (7, COLOR_GREEN, COLOR_BLACK);
  bkgd (COLOR_PAIR(1));

                       /*  TITLE PAGE  */ 

  clear();
  attron (A_NORMAL);
  attron (COLOR_PAIR(2));
  mvprintw (3, 18, "               NUMBER PLEASE\n "
  "                               version 9/29/05\n\n\n\n\n");
  attron (COLOR_PAIR(4));
  mvprintw (9, 32, "By John Slayton\n"
    "                                Copyright  2005\n\n\n\n");
  attron (COLOR_PAIR(5));
  mvprintw (14, 28, "Distributable under GNU\n"
  "                            General Public License\n"
  "                        Contact Free Software Foundation\n"
  "                     51 Franklin St, Boston, MA 02110-1301");
  attron (COLOR_PAIR(2));
  mvprintw (23, 3, "Push Enter to start...");
  refresh();
  getch();

                          /*  PRINT MENU  */

  menu:
  curs_set(0);  /*  extinguish cursor  */
  clear();
  win=0;
  attron (COLOR_PAIR(1));
  mvprintw (3, 10, "                     NUMBER PLEASE\n\n"  
  "                         How Big Will the Number Be?\n\n");
  attron (COLOR_PAIR(2));
  printw ("                               A - One Digit\n\n"
         "                               B - Two Digits\n\n"
         "                               C - Three Digits\n\n" 
         "                               D - Four Digits\n\n\n\n\n\n\n");
  refresh();
  create();
  if (panic == 1)
    {
      bkgd (COLOR_PAIR(2));
      score = 0;
    }
  panic=0;
  if (quitflag == 1)
    {
      return 0;
    }
  goto menu; 
}

int bad()
{
  score = 0;
  bkgd (COLOR_PAIR(6));
  attron (COLOR_PAIR(7));
  attron (A_BLINK);
  mvprintw (15, 50, "YOU GOOFED!");
  mvprintw (20, 50, "SCORE IS %d",score);
  attroff (A_BLINK);
  attron (COLOR_PAIR(6));
  mvprintw (23, 3, "Push return to continue...");
  refresh();
  a = 0;
  while (a != 13)
    {
      a = getch();
      if (a == 27)
        {
          panic = 1;
          bkgd (COLOR_PAIR(2));
          return 0;
        }
    }
  bkgd (COLOR_PAIR(2));
  return 0;
}

int chance()  /*  generates random number  */
{
  while (1 == 1)
    {
      b = random() / (20000000); 
      if(b < 10)
        {
          return 0;
        }
    }
}

/*  create() generates problem with anwswer, calls get_answer() for 
student input and check_answer() to check student's answer  */
 
int create() 
{
                /*  Handle Input From Menu Selection  */

  a = 0;
  while (a != 65 && a != 66 && a != 67 && a != 68
         && a != 97 && a != 98 && a != 99 && a != 100)
    { 
      halfdelay(1); /*  makes getch() non blocking  */
      a = getch(); 

            /*  Produce seed number based on elapsed time  */

      r++; /*  will be random number  */
      if (b > 9)
        {
          r = 0;  /*  Increment on each loop, but never more than 9  */
        }

                /*  convert ASCII input to binary 1-5  */

      if (a > 96)
        {
          d = a - 96;  
        }
       else
         {
           d = a - 64; 
         }
    }

  srandom(r);
  Cycle:  
  nocbreak(); /*  getch() will now wait for keypress  */
  cbreak();  /*  getch() will not wait for EOL  */
  strcpy (C, Z); /*  This clears string C  */
  strcpy (L, Z); /*  This clears string L  */
  strcpy (T, Z); /*  This clears string Z  */
  n1 = 0;
  n2 = 0;
  n3 = 0;
  n4 = 0;
  a1 = 0;
  a2 = 0;
  a3 = 0;
  a4 = 0;
  switch (d) /*  Cases correspond to Menu choices  */
    {
      case 1:  digit1(); /*  Select one digit numbers  */ 
               break;   
      case 2:  digit2(); /*  Select two digit numbers  */
               break;
      case 3:  digit2(); /*  Select three digit numbers  */
               digit3();
               break;
      case 4:  again:  /*  Select four digit numbers  */
               digit1(); 
               if (n1 == 48)
                 {
                   goto again; /*  zero is not accepted  */
                 }
               n4 = n1; /*  first digit guaranteed not zero  */
               digit4();
               digit2();
               digit3();
               strcat (T, L);
               strcpy (L, T);
               break;
      default:
                return 0;
    }
  clear();
  attron (COLOR_PAIR(4));
  mvprintw (5, 3, "Can you type in this number?");
  attron (COLOR_PAIR(2));
  mvprintw (10, 3, "%s", L);
  mvprintw (15, 35, " "); 
  refresh();
  get_answer();
  if (panic == 1)
    {
      return 0;
    }
  check_answer();
  if (panic == 1)
    {
      return 0;
    }
  if (win == 1)
    {
      return 0;
    } 
  goto Cycle;
  return 0;
}

int digit1() /*  Create Ones Digit  */
{
  over:
  chance();
  n1 = b + 48; 
  switch (b) /*  Cases correspond to digit place values  */
    { case 0:  if (d == 1)
                 {
                   strcat(L, N0);
                 }
               break;
      case 1:  strcat (L, N1);
               break;
      case 2:  strcat (L, N2);
               break;
      case 3:  strcat (L, N3);
               break;
      case 4:  strcat (L, N4);
               break;
      case 5:  strcat (L, N5);
               break;
      case 6:  strcat (L, N6);
               break;
      case 7:  strcat (L, N7);
               break;
      case 8:  strcat (L, N8);
               break;
      case 9:  strcat (L, N9);
               break;
    }
  return 0;
}

int digit2()  /*  Create tens digit, then call digit1() to create ones  */
{
  rerun:
  chance();
  if (d == 2 && b == 0) /*  No leading zeros on 2 digit numbers  */
    {
      goto rerun;
    }
  n2 = b + 48;
  switch(b)  /*  Cases correspond to digit values  */
    { 
      case 9:  strcat (L, N90); /*  Go spell 'ninety'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N90);
                 }
               break;
      case 8:  strcat (L, N80); /*  Go spell 'eighty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N80);
                 }
               break;
      case 7:  strcat (L, N70); /*  Go spell 'seventy'  */
               strcat (L, h); 
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                    strcpy (L, N70);
                 }
               break;
      case 6:  strcat (L, N60); /*  Go spell 'sixty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N60);
                 }
               break;
      case 5:  strcat (L, N50); /*  Go spell 'fifty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N50);
                 }
               break;
      case 4:  strcat (L, N40); 
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N40);
                 }
               break;
      case 3:  strcat (L, N30);
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N30);
                 }
               break;
      case 2:  strcat (L, N20);  /* go spell 'twenty'  */
               strcat (L, h);
               digit1(); /*  Go get ones digit  */
               if (b == 0)
                 {
                   strcpy (L, N20);
                 }
               break;
      case 0:  digit1(); /*  Go get ones digit */
               break;
      case 1:  chance();
               n1 = b + 48;
               switch (b) /*  Cases correspond to digit place values  */
                { 
                  case 0:  strcat (L, N10);
                           break;
                  case 1:  strcat (L, N11);
                           break;
                  case 2:  strcat (L, N12);
                           break;
                  case 3:  strcat (L, N13);
                           break;
                  case 4:  strcat (L, N14);
                           break;
                  case 5:  strcat (L, N15);
                           break;
                  case 6:  strcat (L, N16);
                           break;
                  case 7:  strcat (L, N17);
                           break;
                  case 8:  strcat (L, N18);
                           break;
                  case 9:  strcat (L, N19);
                }
    }
  return 0;
}

int digit3()
{
  around:
  chance();
  n3 = b + 48;
  if ((d == 3) && (b == 0))
    {
      goto around; /*  No leading zeros allowed  */
    }
  switch (b) /*  Cases correspond to digit place values  */
    {
      case 1:  strcat (C, N1);
               strcat (C, N100); 
               break;
      case 2:  strcat (C, N2);
               strcat (C, N100);
               break;
      case 3:  strcat (C, N3);
               strcat (C, N100);
               break;
      case 4:  strcat (C, N4);
               strcat (C, N100);
               break;
      case 5:  strcat (C, N5);
               strcat (C, N100);
               break;
      case 6:  strcat (C, N6);
               strcat (C, N100);
               break;
      case 7:  strcat (C, N7);
               strcat (C, N100);
               break;
      case 8:  strcat (C, N8);
               strcat (C, N100);
               break;
      case 9:  strcat (C, N9);
               strcat (C, N100);
               break;
      default: return 0;
    }
  strcat (C, L);
  strcpy (L, C);
  return 0;
}

int digit4()
{
  strcat (T, L);
  strcpy (L, Z);
  strcat (T, N1000);
  return 0;
}

int check_answer()
{
  if ((n1 == a1) && (n2 == a2) && (n3 == a3) && (n4 == a4))
    {
      score = score + 1;
      if (score == 5)
        {
          win = 1;
          WIN();
          return 0;
        }
      good();
    } 
  else bad();
  return 0;
}

int get_answer()
{
  curs_set(1);
  attron (COLOR_PAIR(4));
  a1 = 0;
  a2 = 0;
  a3 = 0;
  a4 = 0;
  mvprintw (15, 2, " ");
  for (nr = d; nr > 0; nr--)
    {
      a = 0;
      while (a < 48 || a > 57)
        {
          a = getch();
          if (a == 13)
            {
              break;
            }
          if (a == 27)
            {
              panic = 1;
              return 0;
            }  
        }
      if (a == 13)
        {
          break;
        }
      if (nr == 4)
        {
          a4 = a;
        }
      if (nr == 3)
        {
          a3 = a;
        }
      if (nr == 2)
        {
          a2 = a;
        }
      if (nr == 1)
        {
          a1 = a;
        }
      printw ("%c", a);
      refresh(); 
    }
  while (a != 13)
    {
      a = getch();
    } 
  curs_set(0);
  attron (COLOR_PAIR(2));
  return 0;
} 

int good()
{
  clear();
  attron (COLOR_PAIR(2));
  mvprintw (5, 35, "GOOD WORK!");
  attron (COLOR_PAIR(1));
  mvprintw (10, 35, "SCORE IS %d", score);
  mvprintw (23, 3, "Push return to continue...");
  refresh();
  a = 0;
  while (a != 13)
    {
      a = getch();
      if (a == 27)
        {
          panic = 1;
          return 0;
        }
    }
   attron (COLOR_PAIR(2));
   return 0;
 }

int WIN()
{
  clear();
  for (a = 0; a < 25; a++)
    {
      attron (COLOR_PAIR(color[a]));
      mvprintw (a, a * 3, "YOU WIN!  "); 
      for (c = 0; c < 15000000; c++) ;
      refresh(); 
    }
  attron (COLOR_PAIR(2));
  getch();
  score=0;
  return 0;
}
