/* This program provides practice writing time, and reading and setting 
traditional clocks.  Nominally formatted as a game, it is designed for 
supplementary activities in a school classroom, part of a collection of 
classroom utilities that may simultaneously run on several virtual 
terminals.

                         SAY WHEN  version 9/28/05
                     Copyright (C) 2005 by John Slayton

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin St, Boston, MA, 02110-1301 USA.

Author's current address is 260 Sundance Ct, Azusa CA 91792.  9/28/05  */

#include <stdio.h>
#include <vga.h>
#include <stdlib.h>
#include <vgakeyboard.h>
#include <time.h>
# define wait(x) keyboard_keypressed(x)

                       /*  VARIABLES  */

int a = 0; /*  Holds subscript for one of 60 hour hands  */
int aa = 0;

int ax = 0; /* In get_answer(), ax: 0 flags hours, 1 flags minutes  */
int b = 0; /*  Holds subscript for one of 60 minute hands  */
int c = 0; /* Holds number of minutes or hours for printnumber()  */
int digit = 0; /*  Counts digits of student answer  */
int direction = 1; /*  1 turns clockwise; -1 turns counterclockwise  */
int hour = 0; /*  Output of random_number(), range is 0 to 59  */
int input_buffer = 0; /* Holds student input digit by digit  */
int minute = 0; /*  Output of random_number(), range is 0 to 59  */
int minute_digit = 0; /* How many digits in minutes of student answer?  */  
int roman_arab_flag = 1; /* Flags numeral style for clockface  */
int panic = 0; /*  Flags return to Menu from deep structure on ESC  */ 
int precision = 0; /*  Tells time to 30, 15, 10, or just 1 minute  */
int score = 0;
int speed_factor = 0; /*  Used to adjust for varying processor speeds  */
int x = 0; /*  With y, shows print position on screen  */
int y = 0; /*  With x, shows print position on screen  */

long int timer1 = 0; /*  Holds initial read of hardware clock  */
long int timer2 = 0; /*  Holds second read of hardware clock  */

time_t *tt = NULL;

    /*  Hour hands will be drawn from center to these coordinates  */

int hour_hand_x[60] = {300, 310, 320, 330, 340, 350, 358, 367, 374, 381,
                       386, 391, 395, 397, 399, 399, 399, 397, 394, 391,
                       386, 380, 373, 366, 358, 349, 340, 330, 320, 309,
                       299, 288, 278, 268, 258, 249, 240, 232, 224, 218,
                       212, 208, 204, 201, 200, 200, 200, 202, 205, 209,
                       214, 219, 226, 234, 242, 251, 260, 270, 280, 291};

int hour_hand_y[60] = {132, 132, 134, 136, 140, 145, 151, 157, 165, 173,
                       182, 191, 201, 211, 221, 232, 242, 253, 263, 273,
                       282, 291, 299, 306, 313, 318, 323, 327, 329, 331,
                       331, 331, 329, 326, 322, 318, 312, 305, 298, 289,
                       281, 271, 261, 251, 241, 230, 220, 209, 199, 190,
                       180, 172, 164, 156, 150, 144, 140, 136, 133, 132};

    /*  Minute hands will be drawn from center to these coordinates  */
  
int minute_hand_x[60] = {300, 316, 333, 349, 365, 380, 394, 407, 419, 429,
                         438, 446, 452, 456, 459, 459, 459, 456, 451, 445,
                         438, 428, 418, 406, 393, 379, 364, 348, 332, 315,
                         298, 281, 265, 249, 233, 218, 204, 191, 179, 169,
                         160, 153, 147, 143, 140, 140, 141, 143, 148, 154,
                         162, 171, 182, 194, 207, 222, 237, 252, 269, 285};

int minute_hand_y[60] = {72, 72, 75, 79, 85, 93, 102, 113, 125, 138,
                         152, 167, 183, 199, 215, 232, 249, 266, 282, 297,
                         312, 326, 339, 351, 362, 371, 378, 384, 388, 391,
                         391, 390, 388, 383, 377, 369, 360, 349, 337, 324,
                         310, 295, 279, 263, 246, 229, 213, 196, 180, 164,
                         150, 136, 123, 111, 101, 92, 84, 79, 74, 72};

         /*  Minute tics will be drawn at these coordinates  */

int tics_x[60] = {300, 320, 341, 361, 381, 400, 417, 434, 448, 462, 
                  473, 482, 490, 495, 498, 499, 498, 495, 489, 482,
                 472, 461, 447, 432, 416, 398, 380, 360, 340, 319,
                 298, 277, 256, 236, 216, 198, 180, 164, 149, 136,
                 125, 116, 109, 103, 100, 100, 101, 104, 110, 118, 
                 128, 139, 153, 168, 184, 202, 221, 241, 261, 282};

int tics_y[60] = {32, 33, 36, 41, 49, 58, 70, 83, 98, 114,
                  132, 151, 170, 191, 211, 232, 253, 274, 294, 314,
                  332, 350, 366, 381, 394, 405, 415, 422, 427, 431,
                  431, 430, 427, 421, 413, 404, 392, 379, 364, 347,
                  330, 311, 291, 271, 250, 229, 208, 187, 167, 148,
                  129, 112, 96, 81, 68, 57, 48, 40, 35, 32};

               /*  Coordinates for clock face hour numbers  */

int xx[12] = {300, 410, 490, 519, 489, 408, 298, 188, 108, 80, 111, 192};
int yy[12] = {11, 41, 122, 232, 343, 423, 451, 421, 339, 229, 119, 39};

int input[2]; /* input[0] holds hours; input[1] holds minutes of student 
input  */

                         /*  METHODS  */

/*  These methods draw text characters  */

int A(), B(), C(), D(), E(), F(), G(), H(), I(), J(), K(), L(), M(),N(); 
int O(), P(), Q(), R(), S(), T(), U(), V(), W(), X(), Y(), Z();
int _(), _0(), _1(), _2(), _3(), _4(), _5(), _6(), _7(), _8(), _9();
int colon(), exclamation_point(), hyphen(), period(), question_mark();

/*  These methods display messages on screen  */

int message1();
int message2();
int message3();
int message4();
int message5();
int message6();

/*  Here are program methods in alphabetical order  */

int arabic_number();
int bad_score();
int count();
int print_problem();
int dialogue_box();
int draw_clock();
int get_answer();
int good_score();
int print_menu();
int print_number();
int puffball();
int random_num();
int read_clock();
int roman_number();
int set_clock();
int set_hands();
int spin_hands();
int stall();
int win();

                            /*  START PROGRAM  */

int main()
{  
  /*  Startup vga functions  */

  vga_init(); 
  keyboard_init();  
  vga_setmode(4);

  /*  Measure processor speed  */

  timer2 = 0; 
  timer1 = time(tt);
  while(timer2 - timer1 < 5)
    {
      timer2 = time(tt);
      speed_factor++;
    }

  /*  Adjust program speed  */

  speed_factor = speed_factor / 5;

  /*  Initialize random numbers  */

  srand(timer1);

  /*  Preliminary displays  */

  message1();
  stall();
  message2();
  stall();

                     /*  CHOOSE FROM MAIN MENU  */

  while (1 == 1)
    {
      panic = 0;

  /*  Present choices  */

      print_menu();

  /*  Make selection  */   

      while (1 == 1)
        {
          if (panic == 1)
            {
              break;
            }
          keyboard_update();
          if (wait (SCANCODE_A)) /*  Select READ CLOCK TO  30 MINUTES  */
            {
              precision = 30;
              read_clock();
              break;            
            }
          if (wait (SCANCODE_B)) /*  Select READ CLOCK TO 15 MINUTES  */
            {
              precision = 15;
              read_clock();
              break;            
            }
          if (wait (SCANCODE_C)) /*  Select READ CLOCK TO 5 MINUTES  */
            {
              precision = 5;
              read_clock();
              break;            
            }
          if (wait (SCANCODE_D)) /*  Select READ CLOCK TO 1 MINUTE  */
            {
              precision = 1;
              read_clock();
              break;            
            }
          if (wait (SCANCODE_E)) /*  Select SET CLOCK TO 30 MINUTES  */
            {
              precision = 30;
              set_clock();
              break;            
            }
          if (wait (SCANCODE_F)) /*  Select SET CLOCK TO 15 MINUTES  */
            {
              precision = 15;
              set_clock();
              break;            
            }
          if (wait (SCANCODE_G)) /*  Select SET CLOCK TO 5 MINUTES  */
            {
              precision = 5;
              set_clock();
              break;            
            }
          if (wait (SCANCODE_H)) /*  Select SET CLOCK TO 1 MINUTE  */
            {
              precision = 1;
              set_clock();
              break;            
            }
          if (wait (SCANCODE_I)) /*  Choose Roman or Arabic numbers  */ 
            {
              roman_arab_flag = roman_arab_flag * (-1);
              count();         
              panic = 1;
              break;
            }
        }
    }
  return 0; 
}                   

                 /*  GENERAL METHODS (in alphabetical order)  */

int arabic_number() /*  Prints Arabic numbers on clock face  */
{
  x = xx[1];
  y = yy[1];
  _1();
  x = xx[2];
  y = yy[2];
  _2();
  x = xx[3];
  y = yy[3] - 6;
  _3();
  x = xx[4];
  y = yy[4];
  _4();
  x = xx[5];
  y = yy[5] - 6;
  _5();
  x = xx[6] - 8;
  y = yy[6] - 6;
  _6();
  x = xx[7] - 16;
  y = yy[7] - 6;
  _7();
  x = xx[8] - 25;
  y = yy[8];
  _8();
  x = xx[9] - 16;
  y = yy[9] - 6;
  _9();
  x = xx[10] - 16;
  y = yy[10];
  _1(); _0();
  x = xx[11] - 16;
  y = yy[11];
  _1(); _1();
  x = xx[0] - 8;
  y = yy[0];
  _1(); _2();
  return 0;
}

int bad_score() /* Reports wrong answer  */
{
  Y();O();U();_();_();G();O();O();F();E();D();exclamation_point();
  x = 10;
  y = 60;
  S();C();O();R();E();_();_();I();S();_();_();S();T();I();L();L();colon();_();
  vga_setcolor(0);
  c = score;
  print_number();
  period();
  return 0;
}

int count()  /*  Stop and count to slow things down  */
{
  for (timer1 = 0; timer1 < 15 * speed_factor; timer1++);
  return 0;
}

int dialogue_box()  /*  Yellow background in top left corner  */
{
  vga_setcolor(14);
  for (x = 0; x < 300; x++)
    {
      for (y = 0; y < 100; y++)
        {
          vga_drawpixel (x, y);
        }
    }
  x = 0;
  y = 0;
  return 0;
}

int  draw_clock() /*  Draw clock without hands  */  
{
  vga_setcolor(12);
  vga_clear(); 
  for (a = 0; a < 60; a++)
    {
      vga_drawline (tics_x[a], tics_y[a], tics_x[a]+1, tics_y[a]); 
    }
  vga_setcolor(10);
  for (a = 0; a < 60; a = a + 5)
    {
      vga_drawline (tics_x[a], tics_y[a], tics_x[a]+2, tics_y[a]);
    }  
  vga_setcolor(11);
  if (roman_arab_flag == 1)
    {
      arabic_number();
    }
  else
    {
      roman_number();
    }
  return 0;
}

int get_answer()
{ 
  input[0] = 0; /* Will hold hours  */
  input[1] = 0; /* Will hold minutes  */ 
  ax = 0;
  message6();  /* "What time was it?"  */
  vga_setcolor(1);
  x = 100;
  y = 70;
  minute_digit = 0;
  for (digit = 0; digit < 5; digit++) 
    {
      while (1 == 1)
        {
          keyboard_update();
          if (wait (SCANCODE_0))
            {
              _0();
              count();
              input_buffer = 0;
              break;
            }
          if (wait (SCANCODE_1))
            {
              _1();
              count();
              input_buffer = 1;
              break;
            }
          if (wait (SCANCODE_2))
            {
              _2();
              count();
              input_buffer = 2;
              break;
            }
          if (wait (SCANCODE_3))
            {
              _3();
              count();
              input_buffer = 3;
              break;
            }
          if (wait (SCANCODE_4))
            {
              _4();
              count();
              input_buffer = 4;
              break;
            }
          if (wait (SCANCODE_5))
            {
              _5();
              count();
              input_buffer = 5;
              break;
            }
          if (wait (SCANCODE_6))
            {
              _6();
              count();
              input_buffer = 6;
              break;
            }
          if (wait (SCANCODE_7))
            {
              _7();
              count();
              input_buffer = 7;
              break;
            }
          if (wait (SCANCODE_8))
            {
              _8();
              count();
              input_buffer = 8;
              break;
            }
          if (wait (SCANCODE_9))
            {
              _9();
              count();
              input_buffer = 9;
              break;
            }
          if (wait (SCANCODE_SEMICOLON))
            {
              colon();
              count();
              input_buffer = 58;
              break;
            }
          if (wait (SCANCODE_ENTER))
            {
              count();
              return 0;
            }
          if (wait (SCANCODE_ESCAPE))
            {
              panic = 1;
              return 0;
            }
        }
      if (input_buffer != 58)
        {
          if(ax == 1)
            {
              minute_digit++;
            }
          input[ax] = 10 * input[ax] + input_buffer;
        }
       else
         {
           ax = 1;
         }
    }
  stall();
  return 0;
}

int good_score()  /*  Report right answer and new score  */
{
  score++;
  G();O();O();D();_();_();A();N();S();W();E();R();exclamation_point();
  x = 10;
  y = 60;
  S();C();O();R();E();_();_();I();S();colon();_();
  vga_setcolor(0);
  c = score;
  print_number();
  period();
  return 0;
}

int message1()  /*  "...say when version..." etc  */
{
  vga_clear();
  x = 240;
  y = 100;
  S();A();Y();_();W();H();E();N();
  x = 180;
  y = 125;
  V();E();R();S();_();
  _0();_9();hyphen();_2();_8();hyphen();_2();_0();_0();_5();
  x = 200;
  y = 400; 
  B();Y();_();J();O();H();N();_();S();L();A();Y();T();O();N();
  x = 200;
  y = 425; 
  C();O();P();Y();R();I();G();H();T();_();_2();_0();_0();_5();
  return 0;
}

int message2()  /*  "...gnu general public license..."  */
{ 
  vga_clear();
  x = 1;
  y = 100;
  D();I();S();T();R();I();B();U();T();A();B();L();E();
  _();U();N();D();E();R();
  x = 1;
  y = 125;
  G();N();U();_();G();E();N();E();R();A();L();_();
  P();U();B();L();I();C();_();L();I();C();E();N();S();E();
  x = 1;
  y = 250;
  F();R();E();E();_();S();O();F();T();W();A();R();
  E();_();F();O();U();N();D();A();T();I();O();N();
  x = 1; 
  y = 275;
  _5();_1();_();F();R();A();N();K();L();I();N();_();S();T();
  x = 1;
  y = 300;
  B();O();S();T();O();N();_();M();A();
  _();_0();_2();_1();_1();_0();
  return 0;
}

int message3() /*  "Write this time on your paper"  */
{
  vga_setcolor(14);
  x = 21;
  y = 1;
  W();R();I();T();E();_();_();
  T();H();E();_();_();T();I();M();E();
  x = 380;
  O();N();_();_();
  Y();O();U();R();_();_();P();A();P();E();R();
  period();
  return 0;
}

int message4() /*  "Push enter to continue."  */
{
  x = 80;
  y = 450; 
  P();U();S();H();_();_(); E();N();T();E();R();
  x = 350;
  T();O();_();_();
  C();O();N();T();I();N();U();E();
  period();
  return 0;  
} 
     
int message5() /*  "Set the clock."  */
{
  x = 400;
  y = 450;
  S();E();T();_();T();H();E();_();C();L();O();C();K();
  count();
  period();
  return 0;
}

int message6() /*  "What time was it?"  */
{
  dialogue_box();
  vga_setcolor(0);
  x = 10;
  y = 10;
  W(); H(); A(); T(); _(); _(); T(); I();
  M(); E(); _(); _(); W(); A(); S(); _(); _(); I(); T();question_mark();       
  return 0;
}

int print_menu()
{
  vga_setmode(4);
  vga_setcolor(13);  
  x = 200;
  y = 20;
  R();E();A();D();_();C();L();O();C();K();
  vga_setcolor(14);
  x = 150;
  y = 61;
  A();_();hyphen();
  _();T();O();_();_3();_0();_();M();I();N();U();T();E();S();
  x = 150;
  y = 86;
  B();_();hyphen();
  _();T();O();_();_1();_5();_();M();I();N();U();T();E();S();
  x = 150;
  y = 111;
  C();_();hyphen();
  _();T();O();_();_5();_();M();I();N();U();T();E();S();
  x = 150;
  y = 136;
  D();_();hyphen();
  _();T();O();_();_1();_();M();I();N();U();T();E();     
  vga_setcolor(13);
  x = 200;
  y = 186;
  S();E();T();_();C();L();O();C();K();
  vga_setcolor(14);
  x = 150;
  y = 236;
  E();_();hyphen();
  _();T();O();_();_3();_0();_();M();I();N();U();T();E();S();
  x = 150;
  y = 261;
  F();_();hyphen();
  _();T();O();_();_1();_5();_();M();I();N();U();T();E();S();
  x = 150;
  y = 286;
  G();_();hyphen();
  _();T();O();_();_5();_();M();I();N();U();T();E();S();
  x = 150;
  y = 311;
  H();_();hyphen();
  _();T();O();_();_1();M();I();N();U();T();E();
  vga_setcolor(13);
  x = 200;
  y = 361;
  C();L();O();C();K();_();F();A();C();E();
  vga_setcolor(14);
  x = 150;
  y = 401;
  if (roman_arab_flag == 1)
    {
      I();_();hyphen();
      _();C();H();A();N();G();E();_();T();O();_();R();O();M();A();N();
    }
  else
    {
      I();_();hyphen();_();
      C();H();A();N();G();E();_();T();O();_();A();R();A();B();I();C();
    }
  return 0;
}

int print_number() /*  Used to report score  */
{
  switch (x)
    {
      case 0: _0();break;
      case 1: _1(); break;
      case 2: _2(); break;
      case 3: _3(); break;
      case 4: _4(); break;
      case 5: _5(); break;
      case 6: _6(); break;
      case 7: _7(); break;
      case 8: _8(); break;
      case 9: _9(); break;
      case 10: _1(); _0(); break;
      case 11: _1(); _1(); break;
      case 12: _1(); _2(); break;
    }
  return 0; 
}   

int print_problem() /*  Prints target time for setting the clock  */
{ 
  aa = 3;
  dialogue_box();
  vga_setcolor(1);
  vga_clear();
  x = 28;
  y = 40;
  W(); R();I();T();E();_();T();H();I();S();_();T();I();M(); E();_();O();
  N();_();Y();O();U();R();_();P();A();P();E();R();colon(); _();_();
  random_number();
  c = hour;
  if (c == 0)
    {
      c = 12;
    }
  vga_setcolor(14);
  print_number();
  colon();
  c = minute / 10;
  print_number();
  c = minute % 10;
  print_number();
  count();
  stall();
  period();
  return 0;  
}
       
int puffball()  /*  Part of win display  */
{ 
  for (x = 0; x < 60; x++)
    {
      vga_drawline (240, 240, minute_hand_x[x], minute_hand_y[x]);
      for (timer1 = 0; timer1 < speed_factor; timer1++);
    }
    return 0;
}

int random_number()  /* Reports 2 numbers, in 'minute' and 'hour'  */
{
  minute = 60;
  hour = 60;
  while ((minute > 59) || (minute % precision > 0))
    {
      minute = rand() / 10000000;
    }
  while (hour > 59)
    {
      hour = rand() / 10000000;
    }
  hour = hour / 5;
  return 0;
}

int read_clock()  /* Principle method for clock reading game  */
{
  score = 0; 
  panic = 0;
  while (1 == 1)
    {
      random_number();
      draw_clock();
      spin_hands();
      message3();
      stall();
      if (panic == 1)
        {
          return 0;
        }
      get_answer();
      if (panic == 1)
        {
          return 0;
        }
      dialogue_box();
      vga_setcolor(1); 
      x = 10;
      y = 20;
      if (hour == 0)
        {
          hour = 12;
        }
      if ( (input[0] == hour) && (input[1] == minute)
            && (minute_digit == 2) )
        {
          good_score();
        }
      else
        {
          bad_score();
        }
      if (score == 5)
        {
          win();
          print_menu();
          return 0;
        }
      stall();
    }
}

int roman_number()  /*  Prints Roman numerals on clock fact  */
{
  x = xx[1];
  y = yy[1];
  I();
  x = xx[2];
  y = yy[2];
  I(); I();
  x = xx[3];
  y = yy[3] - 6;
  I();  I(); I();
  x = xx[4];
  y = yy[4];
  I(); V();
  x = xx[5];
  y = yy[5] - 6;
  V();
  x = xx[6] - 8;
  y = yy[6] - 6;
  V(); I();
  x = xx[7] - 16;
  y = yy[7] - 6;
  V(); ;I(); I();
  x = xx[8] - 25;
  y = yy[8];
  V(); I(); I(); I();
  x = xx[9] - 16;
  y = yy[9] - 6;
  I(); X();
  x = xx[10] - 16;
  y = yy[10];
  X();
  x = xx[11] - 16;
  y = yy[11];
  X(); I();
  x = xx[0] - 8;
  y = yy[0];
  X(); I(); I();
  return 0;
}

int set_clock() /*  Principle method for clock setting game  */
{
  score = 0;
  while (1==1)
    {
      panic = 0;
      print_problem();
      if (panic == 1)
        {
          return 0;
        }
      draw_clock();
      vga_setcolor(14);
      message5();
      set_hands();
      if (panic == 1)
        {
          return 0;
        }

   /*  Evaluate student answer  */
  
      vga_setcolor(0);
      message5();
      dialogue_box();
      vga_setcolor(1);
      x = 10;
      y = 20;
      if ((b == minute) && (a / 5 == hour))
        {
          good_score();
        }
      else 
        {
          bad_score();
         }
      if (score == 5)
        {
          for (ax = 0; ax < 10; ax++)
            {
              count();
            }
          win();
          return 0;
        }
      stall();
      if (panic == 1)
        {
          return 0;
        }
    }
}

int set_hands() /*  Rotates hands with CL and CR keyblock  */
{

  /* Draw hour hand a, one of 60  */
 
  for (a = 0; a < 60; a = a)
    {
      if (a == (-1))
        {
          a = 59;
        }

  /* Draw minute hand b, also one of 60  */

      for (b = 0; b < 60; b = b + direction)
        {
          if (b == (-1))
            {
              b = 59;
            }
          vga_setcolor(12);
          vga_drawline (300, 232, minute_hand_x[b], minute_hand_y[b]);
          vga_setcolor(10);
          vga_drawline (300, 232, hour_hand_x[a], hour_hand_y[a]);
          for (timer1 = 0; timer1 < 2 * speed_factor; timer1++);
          while (1 == 1)
            {
              keyboard_update();
              if (wait(SCANCODE_ESCAPE))
                {
                  panic = 1;
                  return 0;     
                }
              if (wait(SCANCODE_CURSORBLOCKRIGHT))
                {
                      for (timer1 = 0; timer1 < 2 * speed_factor; 
                           timer1++);
                      direction = 1;
                      break;
                }
              if (wait (SCANCODE_CURSORBLOCKLEFT))
                {
                      for (timer1 = 0; timer1 < 2 * speed_factor; 
                      timer1++);
                          direction = -1;
                          break;
                }
              if (wait (SCANCODE_ENTER))
                {
                  return 0;
                }
            }
          vga_setcolor(0);
          vga_drawline (300, 232, minute_hand_x[b], minute_hand_y[b]);
          vga_drawline (300, 232, hour_hand_x[a], hour_hand_y[a]);
          if ((direction == 1) && ((b + 1) % 12 == 0))
            {
              a = a + 1;
            }
          if ((direction == -1) && ((b + 1 == 1) || (b + 1 == 13)
               || (b + 1 == 25) || (b + 1 == 37) || (b + 1 == 49)))
            {
              a = a - 1;
            }
          if (a == (-1))
            {
              a = 59;
            }
          if (a == 60)
            {
              a = 0;
            }
        }
    }
    return 0;
}

int spin_hands()   /*  Rotates hands under machine control  */
{
  for (a = 0; a < 60; a = a) /*  Print one of 60 hour hands  */
    {
      for (b = 0; b < 60; b++) /*  Print one of 60 minute hands  */
        {
          vga_setcolor(12);  
          vga_drawline (300, 232, minute_hand_x[b], minute_hand_y[b]);
          vga_setcolor(10);
          vga_drawline (300, 232, hour_hand_x[a], hour_hand_y[a]);   
          for (timer1 = 0; timer1 < speed_factor; timer1++);
          if ((b == minute) && (a / 5 == hour))
            {
              break;
            }
          vga_setcolor(0);
          vga_drawline (300, 232, minute_hand_x[b], minute_hand_y[b]);
          vga_drawline (300, 232, hour_hand_x[a], hour_hand_y[a]);
          if ( (b + 1) % 12  == 0)
            {
              a++;
            }
          keyboard_update();
          if (wait (SCANCODE_ESCAPE))
            {
              panic = 1;
              return 0;
            }
        }
      if ((b == minute) && (a / 5 == hour))
        {
          break;
        }
    }           
  return 0;
}

int stall()  /*  Stop until ENTER  */
{
  while (1 == 1)
    {
      vga_setcolor(2);
      message4();
      keyboard_update();
      if (wait (SCANCODE_ESCAPE))
        {
          panic = 1;
          return 0;
        }
      if (wait (SCANCODE_ENTER))
        {
          count();count();
          return 0;
        }
    }
}

int win()
{
  vga_clear();
  vga_setcolor(14);
  puffball();
  vga_setcolor(12); 
  x = 400;
  y = 450;
  Y(); O(); U(); _(); _(); W(); I(); N();
  score = 0;
  while (1 == 1)
    {
      keyboard_update();
      if (wait (SCANCODE_ESCAPE))
        {
          return 0;
        }
      if (wait (SCANCODE_ENTER))
        {
          count();count();
          return 0;
        }
    }
}

           /*  METHODS TO GENERATE FONT (in alphabetical order)  */

int A()
{
  vga_drawline (x, y, x + 10, y);
  H();
  return 0;
}

int B()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y, x+6, y);
  vga_drawline (x, y+8, x+6, y+8);
  vga_drawline (x, y+15, x+6, y+15);
  vga_drawline (x+6, y, x+10, y+2);
  vga_drawline (x+6, y+15, x+10, y+14);
  vga_drawline (x+6, y+8, x+10, y+6);
  vga_drawline (x+6, y+8, x+10, y+10);
  vga_drawline (x+10, y+2, x+10, y+6);
  vga_drawline (x+10, y+10, x+10, y+14);
  x=x+18;
  return 0;
}

int C()
{
  vga_drawline (x, y, x+10, y);
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y+15, x+10, y+15);
  x=x+18;
  return 0;
}

int D()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y, x+7, y);
  vga_drawline (x, y+15, x+7, y+15);
  vga_drawline (x+7, y, x+10, y+2);
  vga_drawline (x+7, y+15, x+10, y+13);
  vga_drawline (x+10, y+2, x+10, y+13);
  x=x+18;
  return 0;
}

int E()
{
  vga_drawline (x, y+8, x+10, y+8);
  C();
  return 0;
}

int F()
{
  vga_drawline (x, y, x+8, y);
  vga_drawline (x, y+8, x+8, y+8);
  I();
  x = x + 10;
  return 0;
}

int G()
{
  vga_drawline (x+10, y+10, x+10, y+15);
  vga_drawline (x+8, y+10, x+10, y+10);
  C();
  return 0;
}

int H()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y+7, x+10, y+7);
  vga_drawline (x+10, y, x+10, y+15);
  x=x + 18;
  return 0;
}

int I()
{
  vga_drawline (x, y, x, y+15);
  x = x + 9;
  return 0;
}

int J()
{
  vga_drawline (x+5, y, x+5, y+15);
  vga_drawline (x, y+15, x+5, y+15);
  vga_drawline (x, y+9, x, y+15);
  x=x+13;
  return 0;
}

int K()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x+1, y+8, x+9, y);
  vga_drawline (x+1, y+7, x+9, y+15);
  x = x + 18;
  return 0;
}

int L()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y+15, x+8, y+15);
  x = x + 16;
  return 0;
}

int M()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y, x+5, y+9);
  vga_drawline (x+5, y+9, x+10, y);
  vga_drawline (x+10, y, x+10, y+15);
  x = x + 18;
  return 0;
}

int N()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y, x+8, y+15);
  vga_drawline (x+8, y, x+8, y+15);
  x = x + 16;
  return 0;
}

int O()
{
  vga_drawline (x+10, y, x+10, y+15);
  C();
  return 0;
}

int P()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y, x+10, y);
  vga_drawline (x, y+8, x+10, y+8);
  vga_drawline (x+10, y, x+10, y+8);
  x = x + 18;
  return 0;
}

int Q()
{
  return 0;
}

int R()
{
  vga_drawline (x+3, y+8, x+10, y+15);
  P();
  return 0;
}

int S()
{
  vga_drawline (x, y, x, y+7);
  vga_drawline (x, y, x+10, y);
  vga_drawline (x, y+15, x+10, y+15);
  vga_drawline (x, y+8, x+10, y+8);
  vga_drawline (x+10, y+9, x+10, y+15);
  x = x + 18;
  return 0;
}

int T()
{
  vga_drawline (x, y, x+7, y);
  vga_drawline (x+4, y, x+4, y+15);
  x = x + 15;
  return 0;
}

int U()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y+15, x+10, y+15);    
  vga_drawline (x+10, y, x+10, y+15);
  x = x + 18;
  return 0;
}

int V()
{
  vga_drawline (x, y, x+4, y+15);
  vga_drawline (x+4, y+15, x+8, y);
  x = x + 18;
  return 0;
}

int W()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x+1, y+15, x+5, y+5);
  vga_drawline (x+5, y+5, x+9, y+15);
  vga_drawline (x+10, y, x+10, y+15);
  x = x + 18;
  return 0;
}

int X()
{
  vga_drawline (x, y, x+10, y+15);
  vga_drawline (x, y+15, x+10, y);
  x = x + 18;
  return 0;
}

int Y()
{
  vga_drawline (x, y, x+5, y+5);
  vga_drawline (x+5, y+5, x+10, y);
  vga_drawline (x+5, y+5, x+5, y+15);
  x = x + 18;
  return 0;
}

int Z()
{
  vga_drawline (x, y, x+7, y);
  vga_drawline (x+7, y, x, y+15);
  vga_drawline (x, y+15, x+7, y+15);
  x = x + 15;
  return 0;
}

int _()
{
  x = x + 8;
  return 0;
}

int question_mark()
{
  vga_drawline (x, y, x, y+5);
  vga_drawline (x, y, x+10, y);
  vga_drawline (x+10, y, x+10, y+8);
  vga_drawline (x+5, y+9, x+10, y+9);
  vga_drawline (x+5, y+9, x+5, y+11);
  vga_drawline (x+4, y+14, x+6, y+14);
  vga_drawline (x+4, y+15, x+6, y+15);
  x = x + 18;
  return 0;
}

int _0()
{
  vga_drawline (x+10, y, x+10, y+15);
  C();
  return 0;
}

int _1()
{
  vga_drawline (x+5, y, x+5, y+15);
  x = x + 18;
  return 0;
}

int _2()
{
  vga_drawline (x, y, x+10, y);
  vga_drawline (x+10, y, x+10, y+7);
  vga_drawline (x, y+7, x+10, y+7);
  vga_drawline (x, y+7, x, y+15);
  vga_drawline (x, y+15, x+10, y+15);
  x = x + 18;
  return 0;
}

int _3()
{
  vga_drawline (x, y, x+10, y);
  vga_drawline (x+10, y, x+10, y+15);
  vga_drawline (x, y+15, x+10, y+15);
  vga_drawline (x, y+7, x+10, y+7);
  x = x + 18;
  return 0;
}

int _4()
{
  vga_drawline (x, y, x, y+7);
  vga_drawline (x, y+7, x+10, y+7);
  vga_drawline (x+10, y, x+10, y+15);
  x = x + 18;
  return 0;
}

int _5()
{
  vga_drawline (x, y, x+10, y);
  vga_drawline (x, y, x, y+7);
  vga_drawline (x, y+7, x+10, y+7);
  vga_drawline (x+10, y+7, x+10, y+15);
  vga_drawline (x, y+15, x+10, y+15);
  x = x + 18;
  return 0;
}

int _6()
{
  vga_drawline (x, y, x, y+15);
  vga_drawline (x, y+8, x+10, y+8);
  vga_drawline (x+10, y+8, x+10, y+15);
  vga_drawline (x, y+15, x+10, y+15);
  x = x + 18;
  return 0;
}

int _7()
{
  vga_drawline (x, y, x+10, y);
  vga_drawline (x+10, y, x+10, y+15);
  x = x + 18;
  return 0;
}

int _8()
{
  vga_drawline (x, y+7, x+10, y+7);
  O();
  return 0;
}

int _9()
{
  vga_drawline (x, y, x+10, y);
  vga_drawline (x, y, x, y+7);
  vga_drawline (x, y+7, x+10, y+7);
  vga_drawline (x+10, y, x+10, y+15);
  x = x + 18;
  return 0;
}

int colon()
{
  vga_drawline (x+5, y+2, x+5, y+5);
  vga_drawline (x+5, y+10, x+5, y+13);
  x = x + 18;
  return 0;
}

int exclamation_point()
{
  vga_drawline (x, y, x, y+11);
  vga_drawline (x, y+13, x, y+15);
  x = x + 28;
  return 0;
}

int period()
{
  vga_drawline (x, y+13, x, y+15);
  x = x + 28;
  return 0;
}

int hyphen()
{
  vga_drawline (x, y+8, x+10, y+8);
  x = x + 18;
  return 0;
}
